
/*
 *          |          _                     _______________________
 *          |\       _/ \_                  |                       |
 *          | \_    /_    \_                |    Alexandre Botao    |
 *          \   \__/  \__   \               |     www.botao.org     |
 *           \_    \__/  \_  \              |    55-11-8244-UNIX    |
 *             \_   _/     \ |              |  alexandre@botao.org  |
 *               \_/        \|              |_______________________|
 *                           |
 */

/*______________________________________________________________________
 |                                                                      |
 |  This code is free software: you can redistribute it and/or modify   |
 |  it under the terms of the GNU General Public License as published   |
 |  by the Free Software Foundation, either version 3 of the License,   |
 |  or (at your option) any later version.                              |
 |                                                                      |
 |  This code is distributed in the hope that it will be useful,        |
 |  but WITHOUT ANY WARRANTY; without even the implied warranty of      |
 |  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                |
 |  See the GNU General Public License for more details.                |
 |                                                                      |
 |  You should have received a copy of the GNU General Public License   |
 |  along with this code.  If not, see <http://www.gnu.org/licenses/>,  |
 |  or write to the Free Software Foundation, Inc.,                     |
 |  59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.            |
 |______________________________________________________________________|
 */

# include <stdio.h>
# include <stdlib.h>

# ifdef HPUX
/* # define	atoll(X)	(long long)__strtoll(X,(char **)NULL,10) */
# define	NOATOLL
# endif

/*__________________________________________________________________________*/

# ifdef NOATOLL
long long atoll (s) char * s ; {
#	ifdef ORIG
	return (long long) atol (s) ; /* FIXME: code it down ! */
#	else
	long long	tll ;
	sscanf ( s , "%lld" , &tll ) ;
	return tll ;
#	endif
}
# endif

long long bunitz (s) char * s ; {

# define	MAXNUM		100
# define	MAXLET		8

	register	char *		p ;
	register	int		nk , ak ;
			long long	m ;
	static		char		n [128] ;
	static		char		a [16] ;

	for ( nk = ak = 0 , p = s ; *p ; ++p )
		if ( *p >= '0' && *p <= '9' )
			if ( nk < MAXNUM )
				n[nk++] = *p ;
			else
				return 0LL ;
		else
			if ( ak < MAXLET )
				a[ak++] = *p ;
			else
				return 0LL ;

	n[nk] = '\0' ;
	a[ak] = '\0' ;

	switch ( a[0] ) {
		case 's'  : m = 500LL ;			break ;
		case 'S'  : m = 512LL ;			break ;
		case 'k'  : m = 1000LL ;		break ;
		case 'K'  : m = 1024LL ;		break ;
		case 'm'  : m = 1000000LL ;		break ;
		case 'M'  : m = 1048576LL ;		break ;
		case 'g'  : m = 1000000000LL ;		break ;
		case 'G'  : m = 1073741824LL ;		break ;
		case 't'  : m = 1000000000000LL ;	break ;
		case 'T'  : m = 1099511627776LL ;	break ;
		case '\0' :
		default   : m = 1LL ;			break ;
	}

	return m * atoll (n) ;
}

/*__________________________________________________________________________*/

/*
 * vi:nu ts=4
 */
